TEMPORAL MODULE myService

  IMPORT myElevatorDefs;

  PARAMETERS Light     : SET [ Floor -> OnOff ] STATE FCN;
             Location  : Floor                  STATE FCN;
             Direction : Directions             STATE FCN;

  PREDICATES
    Init == /\ :A: f :in: Floor :: Light[f] = "off"
            /\ Location + 1
    ;

  ACTIONS
    PressButton (f:Floor) ==
      /\ Light[f] = "off"
      /\ (Light[f])' = "on"
      /\ UNCHANGED( Location, Direction )
      /\ :A: v :in: Floors :: v # f.ole => (Light[v]) = (Light[v])'
    ;

END myService
