/*---------------------------------------------------------------------------*
 * NavWin.h
 *
 * Michael Geikowski, 21.6.93
 *
 * Generierung und Verwaltung des Navigation und des Bookmark Windows
 *---------------------------------------------------------------------------*/

#include "link.h"

#include <Xm/Xm.h>

// Navigations-Window erzeugen
//----------------------------

void CreateNavWin(Widget toplevel);

// Navigations-Window loeschen
//----------------------------

void DestroyNavWin();

// Anzeige in Navigations-Window loeschen
//---------------------------------------

void ClearNavWin();

// Link im Navigations Window anzeigen
//------------------------------------

void DisplayLink(Link* l, char* SourceMod);

// Bookmark-Window erzeugen
//-------------------------

int CreateBookmarkWin(Widget toplevel, char* specname);

// Bookmark-Window anzeigen
//-------------------------

void DisplayBookmarkWin();

// Bookmark-Window loeschen
//-------------------------

void DestroyBookmarkWin();

// Bookmarks in Datei sichern
//---------------------------

int SaveBookmarks(char* specname);
