TEMPORAL MODULE ProcessC 

IMPORT SysVarDefs;


ACTIONS

 AlphaC == /\  (pc3 = "alpha") /\ ( 0 < semaphore)
           /\  pc3' = "beta"
           /\  semaphore' = semaphore + 1
           /\  UNCHANGED(pc1, pc2, value) 
             ;

 BetaC  == /\ pc3 = "beta"
           /\ pc3' = "gamma"
           /\ (value.z)' = value.z + 1
           /\ UNCHANGED(semaphore, pc1 , pc2, value.x, value.y)
             ;

 GammaC == /\ pc3 = "gamma"
           /\ pc3' = "alpha"
           /\ semaphore' = semaphore - 1 
           /\ UNCHANGED(value, pc1, pc2) 
             ;

 ProcC  == AlphaC \/ BetaC \/ GammaC
             ;
 

END ProcessC
